#include "graphics.h"
#include <stdlib.h>
#include <stdio.h>


const int maxpoint = 50;

void FillTriangle(int x1, int y1, int x2, int y2, int x3, int y3); // egy haromszg fillezese
pont3d fit(pont3d a, pont3d b); // metsz-illeszt
void DrawPoly(pont3d *P, int n); // poligon kirajtolasa
void ot(int x, int y, int i);  // int kiiratasa x,y-ra

int mx,my; // eger koordinatai
int n=5;  // poligon pontainak szama
int cd=0; // fillezsi modszer

/************************************************************/
int main(void)
{
 // valtozok deklaralasa
 pont3d P[maxpoint+1];
 char ch;
 int ap;
 int page=0;
 int gd=DETECT ,gm;
 initgraph(&gd,&gm,"");


 // paletta beallitasa
 setrgbpalette(15,0   , 255, 0);
 for (int i=0; i<15; i++) {
  setrgbpalette(i,i*16   , 0, 0);
 }


 // kezdo poligon pontjai
 P[0].x = 10; P[0].y = 100; P[0].z = 1;
 P[1].x = 100; P[1].y = 25; P[1].z = 1;
 P[2].x = 80; P[2].y = 120; P[2].z = 1;
 P[3].x = 200; P[3].y = 50; P[3].z = 1;
 P[4].x = 80; P[4].y = 170; P[4].z = 1;


do
{
    setactivepage(page^=1);
    cleardevice();
    
    
    // egerkezeles
    mx=egerx;
    my=egery;
    if (!balgomb) ap = getactivepoint3(P,n,20);
    if (ap >= 0 && balgomb) {P[ap].x = mx; P[ap].y = my;}
    
    
    // polygon kirajzolsa
    DrawPoly(P,n);
    
    
    // szoveg kiiratasok
    setcolor(15);
    outtextxy(5,5,"Color Depth: 'c'   |   Inc point: '+'    |   Dec point: '-'");
    for (int i=0; i<n; i++) {
     ot((int)P[i].x,(int)P[i].y,i);
     // poligon vonalakbol
     int k=i+1;
     if (k>n-1) k=0;
     line(P[i].x,P[i].y,P[k].x,P[k].y);
    }


    // billentyu kezeles
    ch=' ';
    if (kbhit()) ch=getch();
    switch (ch){
     case '+': if (maxpoint>=n) { n++; P[n-1].x = random(getmaxx()); P[n-1].y = random(getmaxy()); P[n-1].z = 1; }  break;
     case '-': if (3<n) { n--; }  break;
     case 'c': cd++; if (cd>2) cd=0; break;
    }
    setvisualpage(page);
} while (ch!=27);

closegraph();
return 0;
}




/**********************************************************************/
// fuggoleges egyenes rajzolasa arnyalassal
void myLine(int x, int y1, int y2) {
 int y;
 int c,lc;
 if (y2<y1) { y=y1; y1=y2; y2=y; }

 for (y=y1-1; y<=y2; y++) {
  if ( cd==2 ) { // sok szinu arnyalas
   c=255-round(sqrt( (mx-x)*(mx-x)+(my-y)*(my-y) ));
   if (c<50) c=50;
   setrgbpalette(1,c   , 0, 0);
   putpixel(x,y,1);
  } else { // 16 szinu arnyalas
   c=14-round(sqrt( (mx-x)*(mx-x)+(my-y)*(my-y)  )) / 32;
   if (c<1) c=1;
   putpixel(x,y,c);
  }
 }
 
}


// egy haromszog megrajzolasa
void FillTriangle(int x1, int y1, int x2, int y2, int x3, int y3){
 int xx;
 pont2d p1,p2,p3;
 float d,dy,dy2,yy,yy2;
 int c;

 // p1<p2<p3 x szerint
 if ((x1<=x2)&&(x1<=x3)) {
  p1.x=x1; p1.y=y1;
  if (x2<x3) { p2.x=x2; p2.y=y2; p3.x=x3; p3.y=y3; }
   else { p2.x=x3; p2.y=y3; p3.x=x2; p3.y=y2; }
 } else
  if ((x2<=x1)&&(x2<=x3)) {
   p1.x=x2; p1.y=y2;
   if (x1<x3) { p2.x=x1; p2.y=y1; p3.x=x3; p3.y=y3; }
    else { p2.x=x3; p2.y=y3; p3.x=x1; p3.y=y1; }
   } else
    if ((x3<=x1)&&(x3<=x2)) {
    p1.x=x3; p1.y=y3;
    if (x1<x2) { p2.x=x1; p2.y=y1; p3.x=x2; p3.y=y2; }
     else { p2.x=x2; p2.y=y2; p3.x=x1; p3.y=y1; }
    }



 // a leghosszabb oldal menti y nvekmny meghatarozasa
 // e vonal mentn megyunk vegig, ket reszre osztva
 d=p3.x-p1.x;
 if (d==0) d=1;
 dy=(p3.y-p1.y)/d;


 // az elso szakasz kirajzolasa: p1.x - p2.x
 d=p2.x-p1.x;
 if (d==0) d=1;
 dy2=(p2.y-p1.y)/d;

 yy=0; yy2=0;
 for (xx=p1.x; xx<=p2.x; xx++) {
  if (cd==0) {
   float x = (p1.x + p2.x + p3.x ) / 3;
   float y = (p1.y + p2.y + p3.y ) / 3;
   c=14-round(sqrt( (mx-x)*(mx-x)+(my-y)*(my-y)  )) / 32;
   if (c<2)  c=2;
   setcolor(c);
   int y1=yy+p1.y, y2=yy2+p1.y;
   if (y1<y2) line(xx,y1-1, xx,y2);
    else line(xx,y1, xx,y2-1);
  } else myLine(xx, round(yy)+p1.y, round(yy2)+p1.y);

  yy  += dy;
  yy2 += dy2;
 }


 // a masodik szakasz kirajzolasa: p2.x - p3.x
 d=p3.x-p2.x;
 if (d==0) d=1;
 dy2=(p3.y-p2.y)/d;

 yy2=0;
 for (xx=p2.x; xx<=p3.x; xx++) {
  if (cd==0) {
   float x = (p1.x + p2.x + p3.x ) / 3;
   float y = (p1.y + p2.y + p3.y ) / 3;
   c=14-round(sqrt( (mx-x)*(mx-x)+(my-y)*(my-y)  )) / 32;
   if (c<2)  c=2;
   setcolor(c);
   int y1=yy+p1.y, y2=yy2+p2.y;
   if (y1<y2) line(xx,y1-1, xx,y2);
    else line(xx,y1, xx,y2-1);
  } else myLine(xx, round(yy)+p1.y, round(yy2)+p2.y);

  yy  += dy;
  yy2 += dy2;
 }

}


/**********************************************************************/
// (p1,p2) egyenes s (P) poligon metszspontok szma
int getIcount(pont3d p1, pont3d p2, pont3d *P) { 
     pont3d c1,c2;
     int intersect=0;
     double x,y;


     for (int i=0; i<n; i++) {
      int k=i+1;
      if (k>=n) k=0;

      
      c1 = fit( p1,p2 ); 
      c2 = fit( P[i], P[k] );
      c1 = fit(c1,c2);
      if (c1.z==0) return(1);
      x = c1.x/c1.z; // metszespont
      y = c1.y/c1.z;
     
      if((x>P[i].x && x<P[k].x && y>p1.y && y<p2.y) ||
         (x<P[i].x && x>P[k].x && y>p1.y && y<p2.y) ||
         (x>P[i].x && x<P[k].x && y<p1.y && y>p2.y) ||
         (x<P[i].x && x>P[k].x && y<p1.y && y>p2.y)) {
       //circle(x,y,10);
       intersect++;
       }
     }
     return intersect;
}


// P poligon kirajzolasa
void DrawPoly(pont3d *P, int n) {

    if (n==3) { // ha a poligon egy haromszog
      FillTriangle(P[0].x,P[0].y,P[1].x,P[1].y,P[2].x,P[2].y);
      return;
    }

    pont3d f1,f2;
    
    int p2[n]; // melyik pontokat nem vesszuk szamitasba
    for (int i=0; i<n; i++)
     p2[i]=1;

    for (int k=0; k<n-3; k++) // n-3 db haromszogre bontunk
     for (int i=0; i<n-1; i++) {

     if (p2[i]==-1) continue;
     
     int q=i; // q = i+1
     do {
      q++;
      if (q>n-1) q=0;
     } while (p2[q]==-1);
     
     int r=q; // r = i+2
     do {
      r++;
      if (r>n-1) r=0;
     } while (p2[r]==-1);

     f1.x = (P[i].x + P[r].x) /2;
     f1.y = (P[i].y + P[r].y) /2;
     f1.z = 1;

     f2.x = f1.x-0.000001;
     f2.y = -10;
     f2.z = 1;

     // ha rajzolhato a haromszog
     if (getIcount(P[i],P[r],P) == 0 && getIcount(f1,f2,P) % 2 != 0) {
      p2[q]=-1;
      FillTriangle(P[i].x,P[i].y,P[q].x,P[q].y,P[r].x,P[r].y);

      /*setcolor(15);
      line(P[i].x,P[i].y,P[q].x,P[q].y);
      line(P[i].x,P[i].y,P[r].x,P[r].y);
      line(P[q].x,P[q].y,P[r].x,P[r].y);*/
      i++;
      continue;
      }
     }
     
     // utolso haromszog kirajzolasa ha szukseges
     if (p2[0]!=-1 && p2[1]!=-1 && p2[n]!=-1) {
      f1.x = (P[1].x + P[n-1].x) /2;
      f1.y = (P[1].y + P[n-1].y) /2;
      f1.z = 1;

      f2.x = f1.x-0.00001;
      f2.y = -10;
      f2.z = 1;
      if (getIcount(P[1],P[n-1],P) == 0 && getIcount(f1,f2,P) % 2 != 0)
       FillTriangle(P[1].x,P[1].y,P[0].x,P[0].y,P[n-1].x,P[n-1].y);
     }

}


// metsz-illeszt
pont3d fit(pont3d a, pont3d b) {
 pont3d c;

 c.x= a.y*b.z - a.z*b.y;
 c.y=-a.x*b.z + a.z*b.x;
 c.z= a.x*b.y - a.y*b.x;

 return c;
}


// int kiiratasa x,y-ra
void ot(int x, int y, int i)
{
 char buffer [33];
 itoa (i,buffer,10);
 outtextxy(x,y,buffer);
}




